/* A Bison parser, made from cfgparse.y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

# define	ANALYZE	257
# define	ARCHIVE	258
# define	COPY	259
# define	EOL	260
# define	HUP	261
# define	LOG	262
# define	RESTART	263
# define	RUN	264
# define	SET	265
# define	STOP	266
# define	EQ	267
# define	LBRACE	268
# define	RBRACE	269
# define	LABEL	270
# define	STRING	271
# define	VALUE	272
# define	VARIABLE	273
# define	NUMBER	274

#line 1 "cfgparse.y"

/* $Id: cfgparse.y,v 1.1 2002/04/20 23:27:18 eagle Exp $

   Parse the configuration file.

   Written by Russ Allbery <rra@stanford.edu>
   Copyright 1998, 1999, 2000, 2002
       Board of Trustees, Leland Stanford Jr. University

   This program is free software.  See README included in the distribution
   for terms and conditions.

   Parse the configuration file.  Our end product is a linked list of log
   classes, which the rest of newsyslog will use as data to do the actual
   work (see logs.h for the definitions of all of the relevant structs).
   The input stream comes from the lexer.

   Be warned:  We're pretty much relying on bison here because it makes the
   make process so much easier.  I don't think I'm doing anything
   bison-specific in this, but I'm also not testing against yacc regularly.
   So you may have to use bison. */

#include "expand.h"
#include "logs.h"
#include "utility.h"

#include <grp.h>
#include <pwd.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* We want to have verbose parse error messages. */
#define YYERROR_VERBOSE 1

/* These two functions need to be externally visible. */
void cfgdie(const char *format, ...);
void yyerror(const char *error);

/* This comes from cfgtoken.l and lex. */ 
int yylex(void); 

/* Stuff for internal use only. */
static struct archive *archive(char *template, int count);
static char *cfgexpand(char *string, const char *name);
static char *lookup(char *path);
static void set(char *name, const char *content);
static struct log *merge (struct log *logs, struct log *actions);

/* The FILE that our lexer will read from. */
extern FILE *yyin;

/* The current line of our configuration file (maintained by the lexer). */
extern int cfgline; 

/* Struct to store variable content mappings from set commands. */
struct variable {
    char *name;
    const char *content;
    struct variable *next;
};

/* Stores a linked list of all variables that have been set. */
static struct variable *variables = NULL;
  
/* The final result of our parsing, a linked list of classes. */
static struct class *class;

#line 73 "cfgparse.y"
#ifndef YYSTYPE
typedef union {
    char *string;
    int number;
    struct command *command;
    struct process *process;
    struct log *log;
    struct class *class;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
#ifndef YYDEBUG
# define YYDEBUG 0
#endif



#define	YYFINAL		64
#define	YYFLAG		-32768
#define	YYNTBASE	21

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 274 ? yytranslate[x] : 40)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     6,     9,    12,    13,    16,    18,    20,    24,
      25,    29,    30,    32,    34,    36,    38,    40,    49,    50,
      55,    61,    66,    68,    70,    72,    75,    76,    84,    87,
      90,    91
};
static const short yyrhs[] =
{
      11,    19,    13,    17,     6,     0,     7,    17,     0,    23,
      17,     0,     0,    10,    23,     0,    22,     0,    24,     0,
      12,    25,     6,     0,     0,     9,    25,     6,     0,     0,
      20,     0,    17,     0,    20,     0,    17,     0,    17,     0,
       8,    30,    17,    28,    29,    20,     6,    31,     0,     0,
       3,    30,    23,     6,     0,     4,    30,    17,    20,     6,
       0,     5,    30,    17,     6,     0,    32,     0,    33,     0,
      34,     0,    35,    36,     0,     0,    16,    14,    26,    27,
      31,    36,    15,     0,    21,    38,     0,    37,    38,     0,
       0,    38,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   149,   152,   185,   208,   221,   232,   233,   236,   237,
     240,   241,   244,   245,   259,   260,   277,   290,   316,   319,
     329,   340,   350,   351,   352,   355,   363,   366,   382,   383,
     391,   394
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "ANALYZE", "ARCHIVE", "COPY", "EOL", "HUP", 
  "LOG", "RESTART", "RUN", "SET", "STOP", "\"=\"", "\"{\"", "\"}\"", 
  "LABEL", "STRING", "VALUE", "VARIABLE", "NUMBER", "set", "hup", 
  "arguments", "run", "process", "stop", "restart", "uid", "gid", "log", 
  "logs", "analyze", "archive", "copy", "action", "actions", "block", 
  "class", "file", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    21,    22,    23,    23,    24,    25,    25,    26,    26,
      27,    27,    28,    28,    29,    29,    30,    31,    31,    32,
      33,    34,    35,    35,    35,    36,    36,    37,    38,    38,
      38,    39
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     5,     2,     2,     0,     2,     1,     1,     3,     0,
       3,     0,     1,     1,     1,     1,     1,     8,     0,     4,
       5,     4,     1,     1,     1,     2,     0,     7,     2,     2,
       0,     1
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
      30,     0,     0,    30,    30,    31,     0,     9,    28,    29,
       0,     0,    11,     0,     0,     4,     6,     7,     0,     0,
      18,     1,     2,     5,     8,     0,     0,    26,     3,    10,
      16,     0,     0,     0,     0,    22,    23,    24,    26,     0,
       0,     4,     0,     0,    25,    27,    13,    12,     0,     0,
       0,     0,    15,    14,     0,    19,     0,    21,     0,    20,
      18,    17,     0,     0,     0
};

static const short yydefgoto[] =
{
       3,    16,    23,    17,    18,    12,    20,    48,    54,    31,
      27,    35,    36,    37,    38,    39,     4,     5,    62
};

static const short yypact[] =
{
     -10,   -11,    -4,   -10,   -10,-32768,     8,    -9,-32768,-32768,
       5,    -5,    14,    18,     9,-32768,-32768,-32768,    19,    -5,
      20,-32768,-32768,    12,-32768,    21,    13,    10,-32768,-32768,
  -32768,    15,    13,    13,    13,-32768,-32768,-32768,    10,    22,
     -13,-32768,    17,    23,-32768,-32768,-32768,-32768,    -8,    -6,
      11,    27,-32768,-32768,    24,-32768,    29,-32768,    30,-32768,
      20,-32768,    38,    39,-32768
};

static const short yypgoto[] =
{
  -32768,-32768,     0,-32768,    26,-32768,-32768,-32768,-32768,   -16,
     -18,-32768,-32768,-32768,-32768,    25,-32768,    16,-32768
};


#define	YYLAST		63


static const short yytable[] =
{
      55,     1,    14,    11,    46,    15,     2,    47,     6,    52,
       7,    28,    53,    32,    33,    34,    41,    42,    43,     8,
       9,    10,    13,    19,    21,    24,    22,    29,    26,    28,
      30,    56,    40,    57,    50,    59,    60,    45,    63,    64,
      51,    49,    61,     0,    58,    25,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    44
};

static const short yycheck[] =
{
       6,    11,     7,    12,    17,    10,    16,    20,    19,    17,
      14,    17,    20,     3,     4,     5,    32,    33,    34,     3,
       4,    13,    17,     9,     6,     6,    17,     6,     8,    17,
      17,    20,    17,     6,    17,     6,     6,    15,     0,     0,
      17,    41,    60,    -1,    20,    19,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    38
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/pubsw/lib/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/pubsw/lib/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 1:
#line 149 "cfgparse.y"
{ set(yyvsp[-3].string, yyvsp[-1].string); ;
    break;}
case 2:
#line 153 "cfgparse.y"
{
                      struct process *process;
                    
                      process = xmalloc(sizeof(struct process));
                      process->command = NULL;
                      process->pidfile = cfgexpand(yyvsp[0].string, "");
                      yyval.process = process;
                  ;
    break;}
case 3:
#line 186 "cfgparse.y"
{
                      struct command *command = yyvsp[-1].command;
                      int size;

                      /* Check to see if we need to grow our array.  Note
                         that the size has to be *larger* than argc so that
                         we have room for the terminating NULL. */
                      command->argc++;
                      if (command->argc >= command->size) {
                          command->size *= 2;
                          size = command->size * sizeof(char *);
                          command->argv = xrealloc(command->argv, size);
                      }

                      /* Aesthetically, the "name" argument of expand()
                         should probably be the block label, but we don't
                         have easy access to that here and my sense of
                         aesthetics isn't strong enough to get me to
                         restructure code to get at it.... */
                      command->argv[command->argc - 1] = cfgexpand (yyvsp[0].string, "");
                      command->argv[command->argc] = NULL;
                  ;
    break;}
case 4:
#line 209 "cfgparse.y"
{
                      struct command *command;
                    
                      command = xmalloc(sizeof(struct command));
                      command->argc = 0;
                      command->size = 3;
                      command->argv = xmalloc(3 * sizeof (char *));
                      command->next = NULL;
                      yyval.command = command;
                  ;
    break;}
case 5:
#line 222 "cfgparse.y"
{
                    struct process *process;
                  
                    process = xmalloc(sizeof(struct process));
                    process->command = yyvsp[0].command;
                    process->pidfile = NULL;
                    yyval.process = process;
                ;
    break;}
case 6:
#line 232 "cfgparse.y"
{ yyval.process = yyvsp[0].process; ;
    break;}
case 7:
#line 233 "cfgparse.y"
{ yyval.process = yyvsp[0].process; ;
    break;}
case 8:
#line 236 "cfgparse.y"
{ yyval.process = yyvsp[-1].process; ;
    break;}
case 9:
#line 237 "cfgparse.y"
{ yyval.process = NULL; ;
    break;}
case 10:
#line 240 "cfgparse.y"
{ yyval.process = yyvsp[-1].process; ;
    break;}
case 11:
#line 241 "cfgparse.y"
{ yyval.process = NULL; ;
    break;}
case 12:
#line 244 "cfgparse.y"
{ yyval.number = yyvsp[0].number; ;
    break;}
case 13:
#line 246 "cfgparse.y"
{
                      struct passwd *pw;

                      pw = getpwnam(yyvsp[0].string);
                      if (pw) {
                          free(yyvsp[0].string);
                          yyval.number = pw->pw_uid;
                      } else {
                          cfgdie("Unknown user %s", yyvsp[0].string);
                      }
                  ;
    break;}
case 14:
#line 259 "cfgparse.y"
{ yyval.number = yyvsp[0].number; ;
    break;}
case 15:
#line 261 "cfgparse.y"
{
                      struct group *gr;

                      gr = getgrnam(yyvsp[0].string);
                      if (gr) {
                          free(yyvsp[0].string);
                          yyval.number = gr->gr_gid;
                      } else {
                          cfgdie("Unknown group %s", yyvsp[0].string);
                      }
                  ;
    break;}
case 16:
#line 278 "cfgparse.y"
{
                      struct log *log;

                      log = xmalloc(sizeof(struct log));
                      log->name = yyvsp[0].string;
                      log->rotate = 0;
                      log->analyze = NULL;
                      log->archive = NULL;
                      yyval.log = log;
                  ;
    break;}
case 17:
#line 291 "cfgparse.y"
{
                      struct log *log;
                      int mode, factor;

                      log = yyvsp[-6].log;
                      log->path = cfgexpand(lookup(yyvsp[-5].string), log->name);
                      log->tmppath = NULL;
                      log->owner = (uid_t) yyvsp[-4].number;
                      log->group = (gid_t) yyvsp[-3].number;
                      mode = yyvsp[-2].number;

                      /* Interpret the permissions as octal.  Roll our own
                         converter to avoid needless weird library calls. */
                      factor = 1;
                      log->mode = 0;
                      while (mode > 0) {
                          log->mode += (mode % 10) * factor;
                          factor *= 8;
                          mode /= 10;
                      }

                      /* Return a linked list of what we've seen so far. */
                      log->next = yyvsp[0].log;
                      yyval.log = log;
                  ;
    break;}
case 18:
#line 316 "cfgparse.y"
{ yyval.log = NULL; ;
    break;}
case 19:
#line 320 "cfgparse.y"
{
                      struct log *log;

                      log = yyvsp[-2].log;
                      log->analyze = yyvsp[-1].command;
                      yyval.log = log;
                  ;
    break;}
case 20:
#line 330 "cfgparse.y"
{
                      struct log *log;

                      log = yyvsp[-3].log;
                      log->archive = archive(yyvsp[-2].string, yyvsp[-1].number);
                      log->rotate = 1;
                      yyval.log = log;
                  ;
    break;}
case 21:
#line 341 "cfgparse.y"
{
                      struct log *log;

                      log = yyvsp[-2].log;
                      log->archive = archive(yyvsp[-1].string, -1);
                      yyval.log = log;
                  ;
    break;}
case 22:
#line 350 "cfgparse.y"
{ yyval.log = yyvsp[0].log; ;
    break;}
case 23:
#line 351 "cfgparse.y"
{ yyval.log = yyvsp[0].log; ;
    break;}
case 24:
#line 352 "cfgparse.y"
{ yyval.log = yyvsp[0].log; ;
    break;}
case 25:
#line 356 "cfgparse.y"
{
                      struct log *log;

                      log = yyvsp[-1].log;
                      log->next = yyvsp[0].log;
                      yyval.log = log;
                  ;
    break;}
case 26:
#line 363 "cfgparse.y"
{ yyval.log = NULL; ;
    break;}
case 27:
#line 367 "cfgparse.y"
{
                      struct class *block;

                      block = xmalloc(sizeof(struct class));
                      block->name = yyvsp[-6].string;
                      block->stop = yyvsp[-4].process;
                      block->restart = yyvsp[-3].process;
                      block->logs = merge(yyvsp[-2].log, yyvsp[-1].log);
                      yyval.class = block;
                  ;
    break;}
case 28:
#line 382 "cfgparse.y"
{ yyval.class = yyvsp[0].class; ;
    break;}
case 29:
#line 384 "cfgparse.y"
{
                      struct class *block;

                      block = yyvsp[-1].class;
                      block->next = yyvsp[0].class;
                      yyval.class = block;
                  ;
    break;}
case 30:
#line 391 "cfgparse.y"
{ yyval.class = NULL; ;
    break;}
case 31:
#line 394 "cfgparse.y"
{ class = yyvsp[0].class; ;
    break;}
}

#line 705 "/usr/pubsw/lib/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 397 "cfgparse.y"


/* yyerror() is just a simple wrapper around cfgdie(). */
void yyerror(const char *error) { cfgdie(error); }


/* Prepend the current line number to the error message before dying.  This
   needs to not be a static function so that the lexer can pull it in and
   use it as well. */
void
cfgdie(const char *format, ...)
{
    va_list message;

    fprintf(stderr, "config line %d: ", cfgline);
    va_start(message, format);
    vfprintf(stderr, format, message);
    va_end(message);
    fprintf(stderr, "\n");
    exit(1);
}

   
/* We maintain a linked list of variables that have been set, which is used
   later by lookup() when it does variable expansion.  Note that we don't
   check for duplicates; this is intentional, as we want to allow people to
   redefine variables.  We add all new definitions onto the *beginning* of
   the linked list, and then any subsequent lookups will always find the
   latest definition of a variable. */
static void
set(char *name, const char *content)
{
    struct variable *variable;

    /* Allocate a new struct variable and add it to the linked list. */
    variable = xmalloc(sizeof(struct variable));
    variable->name = name;
    variable->content = content;
    variable->next = variables ? variables : NULL;
    variables = variable;
}


/* Given an argument that's supposed to be a path, run it through variable
   expansion if it doesn't start with a slash.  Stuff starting with a slash
   bypasses this entirely; it's somewhat counterintuitive that we still call
   lookup for things that we're not going to look up in the variable table,
   but it made the code neater.  We're being passed in a malloc'd string; if
   we return a variable value (also a malloc'd string, stored in the linked
   list of variables), be sure to free our argument. */
static char *
lookup(char *path)
{
    struct variable *variable;
    char *value;
  
    if (path[0] != '/' && strncmp(path, "./", 2) != 0) {
        for (variable = variables; variable; variable = variable->next)
            if (!strcmp(variable->name, path))
                break;
        if (!variable)
            cfgdie("Undefined variable %s", path);
        free(path);
        value = xmalloc(strlen(variable->content) + 1);
        strcpy(value, variable->content);
        return value;
    } else {
        return path;
    }
}


/* Check over a string for the invalid %s escape and then pass it along to
   expand() so that % expansion can be done.  The time passed to it will be
   0 (indicating to use the current time).  Returns NULL on error.  We free
   the string passed in and return the malloc'd string that expand()
   returns. */
static char *
cfgexpand(char *string, const char *name)
{
    char *p;

    /* Check for invalid % escapes. */
    for (p = string; *p; p++)
        if (*p == '%' && !(*(++p) && strchr("%dmnDMY", *p)))
            cfgdie("Invalid %% escape");

    /* Okay, valid format.  Send it through the real expand(). */
    p = expand(string, name, 0);
    if (!p)
        cfgdie("Unable to expand string");
    free(string);
    return p;
}


/* Construct an archive struct, given a template or variable containing a
   template and the number of old logs to save as arguments.  We allocate a
   new struct archive and return it. */
static struct archive *
archive(char *template, int count)
{
    struct archive *new;
    char *location;
    int length;

    /* Allocate a new archive struct and initialize it. */
    new = xmalloc(sizeof(struct archive));
    new->count = count;
    new->path = NULL;
    new->next = NULL;

    /* Now massage the template according to rotation policy. */
    location = lookup(template);
    length = strlen(location) + 4;
    if (count > 0)
        length += 2;
    new->template = xmalloc(length);
    strcpy(new->template, location);
    if (count > 0)
        strcat(new->template, ".0");
    strcat(new->template, ".gz");
    free(location);

    /* Return the completed archive struct. */
    return new;
}


/* When we originally generated the list of logs and the list of actions, we
   did so as two separate linked lists of logs, as it was easier to convince
   yacc/bison to cope with that.  See the long comments at the top of the
   grammer.  This merges them back together.

   We take two pointers to linked lists of logs; the first will be correct
   for path, owner, group, and mode, and the second will have archives and
   rotate elements filled in.  We return a single pointer to a linked list
   of logs with no duplicates that has everything merged together.

   We have not previously checked to see if we have any duplicate log
   definitions, so we also check this while we're at it.  We call cfgdie()
   on any errors (rather than yyerror(), which can't take variable
   arguments). */
static struct log *
merge(struct log *logs, struct log *actions)
{
    struct log *current, *log, *old;
    struct archive *last;
    struct command *command;
  
    /* Scan logs and make sure that there aren't any duplicates. */
    for (current = logs; current != NULL && current->next != NULL;
         current = current->next)
        for (log = current->next; log != NULL; log = log->next)
            if (strcmp(current->name, log->name) == 0)
                cfgdie("Duplicate log definition for %s", current->name);

    /* Now, step through the actions one at a time, merging their contents
       into logs and freeing the memory used by the actions.  Here's where
       we detect people assigning actions to logs that were never existed,
       so those errors will show up as being at the end of the log class
       block rather than at the archive line itself.  Hurm. */
    for (current = actions; current; ) {
        for (log = logs; log != NULL; log = log->next)
            if (strcmp(log->name, current->name) == 0)
                break;
        if (!log)
            cfgdie("Unknown log %s", current->name);
        if (log->archive) {
            for (last = log->archive; last->next != NULL; last = last->next)
                ;
            last->next = current->archive;
        } else {
            log->archive = current->archive;
        }
        if (log->analyze) {
            for (command = log->analyze; command->next != NULL;
                 command = command->next)
                ;
            command->next = current->analyze;
        } else {
            log->analyze = current->analyze;
        }
        log->rotate |= current->rotate;
        old = current;
        current = current->next;
        free(old->name);
        free(old);
    }

    /* Return the linked list of combined log structs. */
    return logs;
}


/* This is the function that the rest of the world gets to call.  It takes
   in the name of the configuration file, and returns a pointer to a linked
   list of class structs. */
struct class *
read_config(const char *filename)
{
    FILE *config;

    /* Attempt to open our configuration file. */
    config = fopen(filename, "r");
    if (!config)
        die("Cannot open configuration file %s", filename);

    /* Point our lexer at the right file, and then let magic happen. */
    yyin = config;
    if (yyparse())
        die("Parsing of %s failed", filename);
    fclose(config);
    return class;
}
